<#--
  Copyright 2008 jpp Development Team
 
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at
 
      http://www.apache.org/licenses/LICENSE-2.0
 
  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
-->
<#macro SIGNATURE method>
    <#if method.modifiers.access?? >${method.modifiers.access} </#if><#if method.typeParameters?? >${method.typeParameters} </#if>${method.returnType.qualifiedName} ${method.name}(<#rt>
<#list method.parameterTypes as parameterType>
<#if parameterType??>
        ${parameterType.qualifiedName} arg_${parameterType_index}<#if parameterType_has_next>, </#if><#t>
</#if>
</#list>)<#rt>
<#if method.exceptionTypes?? && method.exceptionTypes?size != 0 > throws<#t>
<#list method.exceptionTypes as exceptionType>
 ${exceptionType.qualifiedName}<#if exceptionType_has_next>,</#if>
</#list>
<#else>

</#if>
</#macro>

<#macro CALL method instance = "null">
<#if instance != "null" >${instance}.</#if>${method.name}(<#t>
<#list method.parameterTypes as parameterType>
        arg_${parameterType_index}<#if parameterType_has_next> ,</#if><#t>
</#list>
)<#t>
</#macro>